/************************************************************************/
/*									*/
/*  This is the FEC library 	   				        */
/*									*/
/*  09. Jun. 05  L. Musa & H. Santos					*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <fcntl.h>
#include <tools/get_input.h>
#include <altro/altro.h>
#include <tools/rcc_time_stamp.h>
#include "u2f.h"
#include "fec.h"



int main()
{
u_int ret, rcode, rdata, ccode,cdata;
u_int *reg_data;
float temp=0, ana_v=0, ana_i=0, dig_v=0, dig_i=0;
static char fname[200] = "/home/rcu/NEW_U2F/altro_usb/data_files/test_data";
static char finame[200] = "/home/rcu/NEW_U2F/altro_usb/pedestal/ped_in";
static char foname[200] = "/home/rcu/NEW_U2F/altro_usb/pedestal/ped_out";
u_int system_init = 1, write_read_reg=0, write_read_pmem=0, readout=0, write_read_bc=0;
u_int read_FEC_mADC=1, write_read_FM=0, usb_test =0, endurance =0;
u_int tick, point;

/***********************************************************
    System Initialization 
***********************************************************/
if(system_init)   
{
/* Open U2F_LIB */
ret = U2F_Open(HW, DEFAULT_NODE);
if (ret)
  rcc_error_print(stdout, ret);

/* Open the rcc_time_stamp library */
ret = ts_open(1, TS_DUMMY);
if (ret)
  rcc_error_print(stdout, ret);

/* Switch on FEC with Address = 0  */
rcode = O_ACTFEC;
rdata = 0x1;
ret = U2F_Reg_Write(rcode, rdata);
if (ret)
  rcc_error_print(stdout, ret);
    
/* delay 1000000 us */
ts_delay(1000000);

/* Reset FEC */
ccode = C_FECRST;
cdata = 0;
ret = U2F_Exec_Command(ccode, cdata);
ccode = C_FECRST;
cdata = 0;
ret = U2F_Exec_Command(ccode, cdata);
if (ret)
  rcc_error_print(stdout, ret);

    
/* delay 100 us */
ts_delay(100);
}


/***********************************************************/
/*    WRITE & READ  ALTRO REGISTER			   */	
/***********************************************************/
if(write_read_reg)
{
ret = Write_ALTRO_Reg(1, 0, 0, 0xabcd);
if(ret)
  rcc_error_print(stdout, ret);

ret = Read_ALTRO_Reg(1, 0x0, 0x0, reg_data);
if(ret)
  rcc_error_print(stdout, ret);

printf("Reg 0\t of Channel 0\t of Chip 0\t has the value:\t%x\n", *reg_data);
}

/***********************************************************/
/*    WRITE & READ  Pedestal Memory			   */	
/***********************************************************/
if(write_read_pmem)
{
printf("opening file: \n%s\n", finame);
ret = Write_ALTRO_PMEM(1, 1, 0, 128, finame);
if(ret)
  rcc_error_print(stdout, ret);

/* delay 1s */
ts_delay(1000000);

ret = Read_ALTRO_PMEM(0, 0, 128, foname);
if(ret)
  rcc_error_print(stdout, ret);

}

/***********************************************************/
/*    			Data Readout			   */	
/***********************************************************/
if(readout)
{
/*  while(readout)
  { */
    printf("\nCalling FEC_Event_Readout\n");
    ret = FEC_Event_Readout(1, 0, 0, 1, 64, fname);  
/*  } */
}

/***********************************************************/
/*    WRITE & READ  ALTRO REGISTER			   */	
/***********************************************************/
if(write_read_bc)
{
ret = FEC_BC_Reg_Write(1, 0, 0x10, 0xabcd);
if(ret)
  rcc_error_print(stdout, ret);

ret = FEC_BC_Reg_Read(1, 0, 0x10, reg_data) ;
if(ret)
  rcc_error_print(stdout, ret);

printf("\nBC Reg 0x06 = %x\n", *reg_data);
}


/***********************************************************/
/*    READ  FEC Monitoring ADC  			   */	
/***********************************************************/
if(read_FEC_mADC)
{
ret = FEC_BC_Mon(1, 0, &temp, &ana_v, &ana_i, &dig_v, &dig_i);
printf("\nTemp: %f\nAna_V: %f\nAna_I: %f\nDig_V: %f\nDig_I: %f\n", temp, ana_v, ana_i, dig_v, dig_i);
if(ret)
  printf("\nFEC_BC_Mon failed\n");
}

/***********************************************************/
/*    Write and Read FEC's Flash Memory			   */	
/***********************************************************/
/*if(write_read_FM)
{
ret = FEC_FM_Write(1, 0, 8, fm_indata)  */



/***********************************************************/
/*    Test I2C Communication				   */	
/***********************************************************/
if(usb_test)
{
  while(usb_test)
  {
    ret = U2F_Reg_Write(O_FMIREG, 0xabcd);
    if (ret)
      rcc_error_print(stdout, ret);
      
    ret = U2F_Reg_Read(O_FMIREG, reg_data);
    if (ret)
      rcc_error_print(stdout, ret);
      
    printf("U2F Register O_FMIREG:\t%x\n", *reg_data);
  }
}


/***********************************************************/
/*    Endurance Test            			   */	
/***********************************************************/
if(endurance)
{
  tick =0;
  while(endurance)
  {
    tick++;

/*    ret = U2F_Reg_Read(O_ACTFEC, &rdata);  */
    if (ret)
      rcc_error_print(stdout, ret);
      
    if(tick == 5000)
    {
      printf("point = %d, tick=%d\n", point, tick);
      point++;
      tick = 0;
    } 
    if(point == 10)
    {
      printf("point = %d, tick=%d\n", point,tick);
      return(0);  		
    }
    ret = U2F_Reg_Write(O_ACTFEC, 0x0); 
  }
}


ret = U2F_Close();
ret = ts_close(TS_DUMMY);  
exit(0);
}

